/* fichero gseidel.c */
#include <stdio.h>
#include <math.h>
#define  EPS   10.e-12

void main(void) {
    double a[10][10], x[10], b[10], xn;
    double error, modulo, suma;
    int n, i, j, nit=0;

    printf("\nNumero de ecuaciones: ");
    scanf("%d", &n);

    for (i=0; i<n; i++) {
        for (j=0; j<n; j++) {
            printf("Elemento a(%d,%d): ", i+1, j+1);
            scanf(" %lf", &a[i][j]);
        }
    }
    printf("\n");
    for (i=0; i<n; i++) {
        printf("Elemento b(%d): ", i+1);
        scanf(" %lf", &b[i]);
    }
 
    /* valores para iteracin inicial */
    for (i=0; i<n; i++)
        x[i] = b[i]/a[i][i];

    do {
        error=0.0;
        modulo=0.0;
        nit++;
        for(i=0; i<n; i++) {
            suma=0.0;
            for (j=0; j<n; j++)
                if (j!=i)
                    suma+=a[i][j]*x[j];
            xn=(b[i]-suma)/a[i][i];
            error+=(xn-x[i])*(xn-x[i]);
            x[i]=xn;
            modulo+=xn*xn;
        }
    } while (fabs(error/modulo)>EPS);

    printf("\nNumero de iteraciones: %d", nit);    
    printf("\nEl vector solucion es:");
    for (i=0; i<n; i++)
        printf("\nx(%d) = %lf", i+1, x[i]);
    printf("\n");
}
